//
// C++ Implementation: kpgdatatablechildview
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "kpgdatatablechildview.h"

#include <qlayout.h>

#include <kiconloader.h>

// application specific includes
#include "../DbObjects/kpgconnection.h"
#include "../DbObjects/kpgtable.h"
#include "../kpogreview.h"
#include "kpgdatatable.h"

KPGDataTableChildView::KPGDataTableChildView(KPoGreView *pPoGreView, 
	KPGConnection *pConnection,
	const QString & strNamespace,
	KPGTable *pTable,
	const MapIndexKey & mapIndexKey,
	const QString &strWherePredicate,
	const QString & strOrderByPredicate)
 : KMdiChildView(pTable->text(0), pPoGreView, "KPGDataTableChildView")
{
	m_pPoGreView = pPoGreView;
	m_pDataTable = new KPGDataTable(this, 
		pConnection, 
		strNamespace, 
		pTable, 
		mapIndexKey,
		strWherePredicate, 
		strOrderByPredicate);
	
	m_pLayout = new QHBoxLayout(this, 0, -1, "layout" );
	m_pLayout->addWidget( m_pDataTable, 0, 0 );
	
	setIcon(SmallIcon("data"));
}

KPGDataTableChildView::~KPGDataTableChildView()
{
}

bool KPGDataTableChildView::requestClose()
{
	if(m_pDataTable->running())
	{
		KMessageBox::sorry(this, i18n("Reload query is running, cannot close !"));	 
		return false;
	}
	
	
	if(KMessageBox::questionYesNo(this, i18n("Really close data table window ?")) == KMessageBox::Yes) 
	{
		return true;
	}
	return false;
}

