//
// C++ Interface: kpgdatatabledialog
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGDATATABLEDIALOG_H
#define KPGDATATABLEDIALOG_H

#include "kpgdatatabledialogbase.h"

/**
Dialog for setting initial infor for data table

	@author Lumir Vanek <lvanek@users.sourceforge.net>
*/
class KPGDataTableDialog : public KPGDataTableDialogBase
{
	Q_OBJECT
public:
    KPGDataTableDialog(QWidget *);
    ~KPGDataTableDialog();

	const QString & wherePredicate() const { return m_strWherePredicate; }
	const QString & orderByPredicate() const { return m_strOrderByPredicate; }
	
	void setWherePredicate(const QString &);
	
	void setOrderByPredicate(const QString &);
	
protected:
	// The WHERE predicate, used to reduce anmount of edited data
	QString m_strWherePredicate;

	// The ORDER BY predicate, used to sort edited data
	QString m_strOrderByPredicate;
	
protected slots:

	virtual void accept();
};

#endif
