//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "kpgdomainconstraint.h"

// include files for KDE
#include <kdebug.h>
#include <kmessagebox.h>
#include <klocale.h>

#include <qtable.h>

#include "kpgdomainconstraintsfolder.h"
#include "../PropertyPages/kpgdomainconstrproppage.h"


KPGDomainConstraint::KPGDomainConstraint(KPGDomainConstraintsFolder *parent, const QString name, pqxx::oid _oid)
  : KPGObject(parent, name, _oid)
{
  setPixmap(0, *m_pIconCheckConstr);
}

KPGDomainConstraint::KPGDomainConstraint(KPGDomainConstraintsFolder *parent, KPGDomainConstraint *after, const QString name, pqxx::oid _oid)
  : KPGObject(parent, after, name, _oid)
{
  setPixmap(0, *m_pIconCheckConstr);
}

KPGDomainConstraint::~KPGDomainConstraint()
{
}

void KPGDomainConstraint::setProperties(
  const QString strDescription,
  const QString strExpression, 
  const QString strNspName
  )
{
  m_strDescription = strDescription;
  m_strExpression = strExpression;
  m_strNspName = strNspName;
}

void KPGDomainConstraint::displayProperties(QWidget *widgetProperies)
{
	if(widgetProperies == 0) return; // be defensive, user may close Properties window
	
	KPGDomainConstrPropPage *pPropertyPage = static_cast <KPGDomainConstrPropPage *> (widgetProperies);
	
	//---------------------------------------------------------------------------
	// Display properties
	QTable *pTableProperties = pPropertyPage->m_pTableProperties;
	
	//--- Header
	// field names
	QHeader* hHeader = pTableProperties->horizontalHeader();
	
	hHeader->setLabel(0, i18n("Name"));
	hHeader->setLabel(1, i18n("Value"));
	hHeader->setLabel(2, i18n("Description"));
	
	int iRow = 0;
		
	//--- OID
	pTableProperties->setText(iRow, 0, i18n("OID"));
	pTableProperties->setText(iRow, 1, QString("%1").arg(m_oid));
	pTableProperties->setText(iRow++, 2, i18n("PostgreSQL row identifier"));
	
	//--- Name
	pTableProperties->setText(iRow, 0, i18n("Name"));
	pTableProperties->setText(iRow, 1, text(0));
	pTableProperties->setText(iRow++, 2, i18n("Constraint name (not necessarily unique!)"));
	
	//--- Description
	pTableProperties->setText(iRow, 0, i18n("Description"));
	pTableProperties->setText(iRow, 1, m_strDescription);
	pTableProperties->setText(iRow++, 2, i18n("Description of the constraint"));
		
	//--- Expression
	pTableProperties->setText(iRow, 0, i18n("Expression"));
	pTableProperties->setText(iRow, 1, m_strExpression);
	pTableProperties->setText(iRow++, 2, i18n("A human-readable representation of the expression"));
	
	//--- Namespace
	pTableProperties->setText(iRow, 0, i18n("Namespace"));
	pTableProperties->setText(iRow, 1, m_strNspName);
	pTableProperties->setText(iRow++, 2, i18n("Name of the namespace"));
	
	for(int nCol = 0; nCol < 3; nCol++)
	{
		pTableProperties->adjustColumn(nCol);
	}
}


