//
// C++ Interface: kpglanguage
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGLANGUAGE_H
#define KPGLANGUAGE_H

#include "kpgobject.h"

class KPGLanguagesFolder;

/**
Item that represent procedural language

@author Lumir Vanek
*/

class KPGLanguage : public KPGObject
{
public:
    KPGLanguage(KPGLanguagesFolder *, const QString, pqxx::oid);
	KPGLanguage(KPGLanguagesFolder *, KPGLanguage *, const QString, pqxx::oid);
    ~KPGLanguage();

	virtual eNodeType type() const { return nodeLanguage; }
	
	// Get SQL object type 
  	virtual const char * getObjectType() const { return "LANGUAGE"; }
	
	void setProperties(bool, const QString, pqxx::oid, const QString, pqxx::oid, const QString);
	void displayProperties(QWidget *);
	virtual bool refresh() { return refreshItem(); }
    bool refreshItem();
	
protected:
	// Language properties		
	bool m_bIsTrusted;	
	QString m_strACL;
	pqxx::oid m_oidLanguageProc;
	QString m_strLanguageProcName;
	pqxx::oid m_oidValidatorProc;
	QString m_strValidatorProcName;
};

#endif
