//
// C++ Interface: kpgrule
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGRULE_H
#define KPGRULE_H

#include "kpgobject.h"

class KPGRulesFolder;

/**
Table rule

@author Lumir Vanek
*/

class KPGRule : public KPGObject
{
public:
    KPGRule(KPGRulesFolder *, const QString, pqxx::oid);
	KPGRule(KPGRulesFolder *, KPGRule *, const QString, pqxx::oid);
    ~KPGRule();

	virtual eNodeType type() const { return nodeRule; }
	
	// Get SQL object type 
  	virtual const char * getObjectType() const { return "RULE"; }
	
	void setProperties(const QString, bool,	const QString, const QString, const QString);
	void setDefinition(const QString strDefinition) { m_strDefinition = strDefinition; }
	void displayProperties(QWidget *);
	
	// Refresh. Behavior depends from type of object
	virtual bool refresh() { return refreshItem(); }
	
	// Refresh only this item, not childs
	virtual bool refreshItem();
		
protected:
	// Object properties
	// name is stored as text(0)
	QString m_strNameSpace;
	bool m_bIsInstead;
	QString m_strEvType;
	QString m_strEvQual;
	QString m_strDefinition;
};

#endif
