//
// C++ Interface: kpgtrigger
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGTRIGGER_H
#define KPGTRIGGER_H

#include "kpgobject.h"

class KPGTriggersFolder;

/**
Table trigger

@author Lumir Vanek
*/

class KPGTrigger : public KPGObject
{
public:
    KPGTrigger(KPGTriggersFolder *, const QString, pqxx::oid);
	KPGTrigger(KPGTriggersFolder *, KPGTrigger *, const QString, pqxx::oid);
    ~KPGTrigger();

	virtual eNodeType type() const { return nodeTrigger; }
	
	// Get SQL object type 
  	virtual const char * getObjectType() const { return "TRIGGER"; }
	
	void setProperties(const QString, bool, bool, bool, int, const QString, const QString, pqxx::oid, const QString);
	void displayProperties(QWidget *);
	
	// Refresh. Behavior depends from type of object
	virtual bool refresh() { return refreshItem(); }
	
	// Refresh only this item, not childs
	virtual bool refreshItem();
	
	bool isEnabled() const { return m_bIsEnabled; }
		
protected:
	// Object properties
	// name is stored as text(0)
	bool m_bIsEnabled;
	bool m_bDeferrable;
	bool m_bInitDeferred;
	int m_iNArgs;
	QString m_strNameSpace;
	QString m_strArgs;
	pqxx::oid m_oidProcedure;
	QString m_strProcName;
};

#endif
