//
// C++ Implementation: kpgexecutorchildview
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "kpgexecutorchildview.h"

#include <qlayout.h>

// include files for KDE
#include <klocale.h>
#include <kiconloader.h>

// application specific includes
#include "../kpogreview.h"
#include "kpgexecutor.h"
#include "../DbObjects/kpgconnection.h"
#include "../DbObjects/kpgdatabase.h"
#include "../DbObjects/kpgfunction.h"

KPGExecutorChildView::KPGExecutorChildView(KPoGreView *pPoGreView,
	KPGConnection * pConnection, 
	const QString & strNamespace, 
	KPGFunction *pFunction)
 : KMdiChildView(pFunction->text(0), pPoGreView, "KPGExecutorChildView")
{
	m_pPoGreView = pPoGreView;
	
	QBoxLayout* pLayout = new QHBoxLayout(this, 0, -1, "layout" );
	m_pExecutor = new KPGExecutor(this, "Function executor", pConnection, strNamespace, pFunction);
	pLayout->addWidget(m_pExecutor);
	
	setIcon(SmallIcon("exec"));
}

KPGExecutorChildView::~KPGExecutorChildView()
{
}

bool KPGExecutorChildView::requestClose()
{
	if(m_pExecutor->running())
	{
		KMessageBox::sorry(this, i18n("Function is running, cannot close !"));	 
		return false;
	}
	
	if(KMessageBox::questionYesNo(this, i18n("Really close executor window ?")) == KMessageBox::Yes) 
	{
		return true;
	}
	return false;
}
