//
// C++ Interface: kpgaggregateproppage
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGAGGREGATEPROPPAGE_H
#define KPGAGGREGATEPROPPAGE_H

#include "kpgaggregateproppagebase.h"

// application specific includes
#include "kpgabstractpropertypage.h"

// include files for libpgxx 
#include <pqxx/util.h> 

/**
Aggregate properties

@author Lumir Vanek
*/

class KPGAggregatePropPage : public KPGAggregatePropPageBase, public KPGAbstractPropertyPage
{
Q_OBJECT
public:
    KPGAggregatePropPage(QWidget *parent = 0, const char *name = 0);
    ~KPGAggregatePropPage();

	// Return Result table for clipboard actions and export. 
	virtual QTable* tableResult() { return m_pTableProperties; }
	
protected slots:
    
	virtual void slotTablePropDblClicked(int, int, int, const QPoint &);	
	                 
    // Consumes request for context menu for property table
	virtual void slotTablePropContextMenuRequested(int, int, const QPoint &);
    	
signals:
	void sigSearchObject(const pqxx::oid);
		            
    // Emit request for context menu for property table
	void sigTablePropContextMenuRequested(int, int, const QPoint &);
};

#endif
