/***************************************************************************
                          kpgdatabaseproppage  -  description
                             -------------------
    begin                : So led 31 2004
    copyright            : (C) 2004 by Lumir Vanek
    email                : lvanek@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "kpgdatabaseproppage.h"

#include "../DbObjects/kpgtreeitem.h"

// include files for Qt
#include <qiconset.h>
#include <qtable.h> 

// include files for KDE
#include <ktabwidget.h>
#include <kiconloader.h>
#include <kpushbutton.h>
#include <klistview.h>
#include <klineedit.h>
#include <kpushbutton.h>
#include <ktextedit.h>
#include <kdebug.h>


#include "../kpglinklabel.h"
#include "../DbObjects/kpgdatabase.h"
#include "../kpgutil.h"


KPGDatabasePropPage::KPGDatabasePropPage(QWidget *parent, KPGDatabase *pDatabase)
 : KPGDatabasePropPageBase(parent, "KPGDatabasePropPage")
{
	m_pDatabase = pDatabase;
  
  	//m_pTableProperties->verticalHeader()->setResizeEnabled( false );
	m_pTabWidget->setTabIconSet(tabCasts, QIconSet(*KPGTreeItem::m_pIconCast)); 
	m_pTabWidget->setTabIconSet(tabLanguages, QIconSet(*KPGTreeItem::m_pIconLanguage)); 
	m_pTabWidget->setTabIconSet(tabSchemas, QIconSet(*KPGTreeItem::m_pIconSchema)); 
	m_pTabWidget->setTabIconSet(tabStatistics, QIconSet(QPixmap(SmallIcon("ksysguard.png")))); 
	m_pButtonRefresh->setIconSet(QIconSet(QPixmap(BarIcon("reload.png")))); 
	m_pTabWidget->setTabIconSet(tabACL, QIconSet(QPixmap(UserIcon("group.png"))));
}


KPGDatabasePropPage::~KPGDatabasePropPage()
{
}

void KPGDatabasePropPage::slotTablePropDblClicked(int iRow, int iCol, int /*iButton*/, const QPoint & /*ptMousePos*/)
{
    QWidget *w = m_pTableProperties->cellWidget(iRow, iCol);
	if(w == 0)
		return;
					
	KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
	pqxx::oid _oid = pLabel->oid();
			
	if(_oid != 0)
		emit sigSearchObject(_oid);
}

void KPGDatabasePropPage::slotTableCastsDblClicked(int iRow, int iCol,int,const QPoint&)
{
    QWidget *w = m_pTableCasts->cellWidget(iRow, iCol);
	if (w == 0)
		return;
					
	KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
	pqxx::oid _oid = pLabel->oid();
			
	if(_oid != 0)
		emit sigSearchObject(_oid);
}

void KPGDatabasePropPage::slotTableLanguagesDblClicked(int iRow, int iCol,int,const QPoint&)
{
    QWidget *w = m_pTableLanguages->cellWidget(iRow, iCol);
	if (w == 0)
		return;
					
	KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
	pqxx::oid _oid = pLabel->oid();
			
	if(_oid != 0)
		emit sigSearchObject(_oid);
}

void KPGDatabasePropPage::slotTableSchemasDblClicked(int iRow, int iCol,int,const QPoint&)
{
    QWidget *w = m_pTableSchemas->cellWidget(iRow, iCol);
	if (w == 0)
		return;
					
	KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
	pqxx::oid _oid = pLabel->oid();
			
	if(_oid != 0)
		emit sigSearchObject(_oid);
}

void KPGDatabasePropPage::slotTableStatistics2DblClicked(int iRow, int iCol,int,const QPoint&)
{
    QWidget *w = m_pTableStatistics2->cellWidget(iRow, iCol);
    if (w == 0)
      return;
          
    KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
    pqxx::oid _oid = pLabel->oid();
      
    if(_oid != 0)
    	emit sigSearchObject(_oid);
}

void KPGDatabasePropPage::slotRefreshStatistics()
{
  	m_pDatabase->displayExtendedStatistics(this);
}

void KPGDatabasePropPage::setACL(const QString &strACL)
{
	m_pListViewACL->clear();
	m_listOfAclItems.clear();
	m_pLineEditACL->setText(strACL);
	
	QString strAclItem; // string for one ACL item, e.g. miriam=arwdRxt/miriam
	for(unsigned int i = 0; i < strACL.length(); i++)
	{
		if(strACL[i] == '{')
		continue;
		
		if((strACL[i] == ',') || (strACL[i] == ','))
		{
			m_listOfAclItems.append(KPGAclItem(strAclItem)); // create new ACL item
			strAclItem.truncate(0); // clear ACL string
		}
		else
		{
			strAclItem.append(strACL[i]);
		}
	}
	
	if(!strAclItem.isEmpty())
		m_listOfAclItems.append(KPGAclItem(strAclItem)); // create new ACL item
	
	// Traverse list of ACL items
	KPGAclItemList::iterator it;
	for ( it = m_listOfAclItems.begin(); it != m_listOfAclItems.end(); ++it )
	{   
		QListViewItem * pItem = new QListViewItem( m_pListViewACL, 0 );
		(*it).setListViewItem(pItem);
		
		pItem->setText( 0, (*it).grantee() );
		pItem->setText( 1, (*it).grantor() );
		
		pItem->setPixmap(2, UserIcon((*it).canCreate() ? "box_checked.png" : "box_clear.png"));
		pItem->setPixmap(3, UserIcon((*it).canCreateTemp() ? "box_checked.png" : "box_clear.png"));
			
		if((*it).canPassGrantToOther())
		{  
		pItem->setPixmap(4, UserIcon((*it).canGrantCreate() ? "box_checked.png" : "box_clear.png"));
		pItem->setPixmap(5, UserIcon((*it).canGrantCreateTemp() ? "box_checked.png" : "box_clear.png")); 
		}
	} 
}

void KPGDatabasePropPage::slotAclListViewClicked(QListViewItem *pItem, const QPoint &, int iColumn)
{
	// Find KPGAclItem using pItem value
	KPGAclItemList::iterator it;
	for ( it = m_listOfAclItems.begin(); it != m_listOfAclItems.end(); ++it )
	{   
		if(pItem == (*it).getListViewItem())
		{
		// found ...
		
		switch(iColumn)
		{
			case 0:
			case 1: // do nothing on first 2 columns
				break;
			
			case 2:
				pItem->setPixmap(2, UserIcon((*it).toggleCreate() ? "box_checked.png" : "box_clear.png"));
				break;
		
			case 3:
				pItem->setPixmap(3, UserIcon((*it).toggleCreateTemp() ? "box_checked.png" : "box_clear.png"));
				break;
			
			case 4:
				if((*it).canPassGrantToOther())
				pItem->setPixmap(4, UserIcon((*it).toggleGrantCreate() ? "box_checked.png" : "box_clear.png"));
				
				break;
			
			case 5:
				if((*it).canPassGrantToOther())
				pItem->setPixmap(5, UserIcon((*it).toggleGrantCreateTemp() ? "box_checked.png" : "box_clear.png"));
				
				break;
				
			default:
					kdError() << k_funcinfo << " Unexpected column !" << endl;
					break;      
		}
		
		m_pPushButtonUpdateACL->setEnabled(true);
		return;
		}
	}
}

void KPGDatabasePropPage::slotUpdateACL()
{
	QString strSQL;
	
	// Traverse all items and get their SQL's
	KPGAclItemList::iterator it;
	for ( it = m_listOfAclItems.begin(); it != m_listOfAclItems.end(); ++it )
	{   
		strSQL.append((*it).getSQL("DATABASE " + KPGUtil::quotedName(m_pDatabase->text(0))));
	}
	
	if(!strSQL.isEmpty())
		emit sigRunWizard(strSQL);
}

// Return Result table for clipboard actions and export. 
QTable* KPGDatabasePropPage::tableResult() 
{ 
	switch(m_pTabWidget->currentPageIndex())
	{
		case 0: return m_pTableProperties; 
				break;
				
		case 1: return 0; 
				break;
				
		case 2: return m_pTableCasts; 
				break;
				
		case 3: return m_pTableLanguages; 
				break;
				
		case 4: return m_pTableSchemas; 
				break;
				
		case 5: return m_pTableStatistics2; 
				break;	
	}
	
	return 0;
}

// Consumes request for context menu for property table
void KPGDatabasePropPage::slotTablePropContextMenuRequested(int row, int col, const QPoint & pos)
{
	emit sigTablePropContextMenuRequested(row, col, pos);	
}

#include "kpgdatabaseproppage.moc"
