//
// C++ Interface: kpgpropertypagechildview
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGPROPERTYPAGECHILDVIEW_H
#define KPGPROPERTYPAGECHILDVIEW_H

#include <kmdichildview.h>

// application specific includes
#include "kpgabstractpropertypage.h"

class KPGTreeItem;
class QBoxLayout;
class KPoGreView;

/**
MDI child view for property pages

	@author Lumir Vanek <lvanek@users.sourceforge.net>
*/
class KPGPropertyPageChildView : public KMdiChildView
{
	Q_OBJECT
public:
    KPGPropertyPageChildView(KPoGreView *);
    ~KPGPropertyPageChildView();
    
    // Create Properties widget, with regards to selected type in tree
  	QWidget* createPropertiesWidget(KPGTreeItem *);
  	
  	// Return the Properties widget
  	//QWidget* getWidgetProperties() const { return m_pWidgetProperties; }
  	
  	// Return the Properties widget
  	KPGAbstractPropertyPage* getPropertyPage() const { return m_pPropertyPage; }

	// Return true, if window can be closed
	bool requestClose();
	
protected:
	// Destroy the Properties widget
	void destroyPropertiesWidget();

signals:
    
    // Emit request for context menu for result table
	void sigTablePropContextMenuRequested(int, int, const QPoint &);
	
	// Fired when Tab with inner properties is switched
	void sigPropertyPageStateChanged(KPGAbstractPropertyPage *);
	
protected slots:

	// Get request for context menu from property table
	void slotTablePropContextMenuRequested(int, int, const QPoint &);

private:
	// Two same pointers to different base classes os property page
	QWidget*	m_pWidgetProperties;
	KPGAbstractPropertyPage* m_pPropertyPage;
	
	QBoxLayout* m_pLayout;
	KPoGreView* m_pPoGreView;
};

#endif
