/***************************************************************************
                          kpgserverproppage  -  description
                             -------------------
    begin                : So led 31 2004
    copyright            : (C) 2004 by Lumir Vanek
    email                : lvanek@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "kpgserverproppage.h"

// include files for Qt
#include <qstring.h>
#include <qtable.h>
#include <qapplication.h>
#include <qclipboard.h>

#include <ktabwidget.h>

// include files for KDE
#include <kiconloader.h>
#include <klineedit.h>
#include <kpushbutton.h>

#include "../kpglinklabel.h"
#include "../DbObjects/kpgserver.h"

KPGServerPropPage::KPGServerPropPage(QWidget *parent, KPGServer *pServer)
 : KPGServerPropPageBase(parent, "KPGServerPropPage")
{
	m_pServer = pServer;
  	m_pTableDatabases->verticalHeader()->setResizeEnabled( false );
  
  	m_pTabWidget->setTabIconSet(tabActivity, QIconSet(QPixmap(SmallIcon("ksysguard.png")))); 
  
  	m_pButtonRefresh->setIconSet(QIconSet(QPixmap(BarIcon("reload.png")))); 
  	m_pButtonCopySql->setIconSet(QIconSet(QPixmap(BarIcon("editcopy.png")))); 
}


KPGServerPropPage::~KPGServerPropPage()
{
}

void KPGServerPropPage::setVersionInfo(const QString strVersionInfo)
{
	m_pLineEditVersion->setText(strVersionInfo);
}

void KPGServerPropPage::slotTablePropDblClicked(int iRow, int iCol, int /*iButton*/, const QPoint & /*ptMousePos*/)
{
    QWidget *w = m_pTableDatabases->cellWidget(iRow, iCol);
    if(w == 0)
      return;
          
    KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
    pqxx::oid _oid = pLabel->oid();
      
    if(_oid != 0)
      emit sigSearchObject(_oid);
}

void KPGServerPropPage::slotRefreshActivity()
{
  m_pServer->displayActivity(this);
}

void KPGServerPropPage::slotCopySql()
{
	int currentRow = m_pTableActivity->currentRow();
	if(currentRow < 0) return;
	
	QString sqlQuery = m_pTableActivity->text(currentRow, 3);
	
	QApplication::clipboard()->setText(sqlQuery);
}

// Consumes request for context menu for property table
void KPGServerPropPage::slotTablePropContextMenuRequested(int row, int col, const QPoint & pos)
{
	emit sigTablePropContextMenuRequested(row, col, pos);	
}

#include "kpgserverproppage.moc"
