//
// C++ Interface: kpgqueryresultchildview
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGQUERYRESULTCHILDVIEW_H
#define KPGQUERYRESULTCHILDVIEW_H

#include <kmdichildview.h>

#include <kurl.h>

class KPGQueryResultWindow;
class KPoGreView;

/**
MDI child view for query/result window

	@author Lumir Vanek <lvanek@users.sourceforge.net>
*/
class KPGQueryResultChildView : public KMdiChildView
{
	Q_OBJECT
public:
    KPGQueryResultChildView(KPoGreView *);
    ~KPGQueryResultChildView();

	KPGQueryResultWindow * getQueryResultWindow() const { return m_pQueryResultWindow; }

	// Initializes the document generally
    bool newDocument();
    
	// Loads the document by filename and format 
    bool openDocument(const KURL& url, const char *format=0);

    // saves the document under filename and format.
    bool saveDocument(const KURL& url, const char *format=0);
    
    // Returns the KURL of the document
    const KURL& URL() const;
    
    // Return true, if SQL script is modified
    const bool isModified() const;

	// Return true, if window can be closed
	bool requestClose();
	
signals:
	
	// Fired when need update tooltip text
	void sigUpdateTabTooltip(KMdiChildView *, const QString &);
	
public slots:

	// Fired when need update tooltip text
	void slotUpdateTabTooltip(const QString &);
	
protected:
	KURL m_urlSqlFile;

private:
	KPGQueryResultWindow *m_pQueryResultWindow;
	KPoGreView* m_pPoGreView;
};

#endif
