//
// C++ Interface: %{MODULE}
//
// Description: 
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KONSOLEVIEWWIDGET_H
#define KONSOLEVIEWWIDGET_H

#include <qwidget.h>
#include <qstring.h>

#include <kurl.h>

/**
Widget that display Konsole using KParts

@author Lumir Vanek
*/


namespace KParts {
  class ReadOnlyPart;
  class Part;
  class PartManager; 
}
class QVBoxLayout;


class KonsoleViewWidget : public QWidget
{
    Q_OBJECT
public:
    KonsoleViewWidget(KParts::PartManager *, QWidget *);
    virtual ~KonsoleViewWidget();

    virtual void show();
    
public slots:
    void setDirectory(const KURL &dirUrl);
    void activePartChanged(KParts::Part *activatedPart);
        
private slots:
    void partDestroyed();
        
private:
    void activate();

    KParts::ReadOnlyPart *part;
    QVBoxLayout *vbox;
    KParts::PartManager *m_pPartManager;
};

#endif
