//
// C++ Interface: %{MODULE}
//
// Description: 
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGCREATECOMPOSITETYPEWIDGET2_H
#define KPGCREATECOMPOSITETYPEWIDGET2_H

#include "kpgcreatecompositetypewidget2base.h"

class KPGDatabase;

/**
Widget for create composite type Wizard

@author Lumir Vanek
*/

class KPGCreateCompositeTypeWidget2 : public KPGCreateCompositeTypeWidget2Base
{
Q_OBJECT
public:
    KPGCreateCompositeTypeWidget2(QWidget *parent, const char *name, KPGDatabase *);
    ~KPGCreateCompositeTypeWidget2();

    const QString getSQL() const;

protected:
    void refreshListOfTypes();
    void fillUserDatatypes();    
      
protected:    
     KPGDatabase *m_pDatabase;
     
protected slots:

    virtual void slotAttributeNameChanged(const QString&);
    virtual void slotSchemaActivated(int);
    virtual void slotComboDataTypeActivated(const QString &);
    virtual void slotNumDimensionsChanged(int);
    
    virtual void slotAttributeSelectionChanged(QListViewItem *);
    virtual void slotAttributeCurrentChanged(QListViewItem *);
    
    virtual void slotAttributeAdd();
    virtual void slotAttributeDelete();
    virtual void slotAttributeUp();
    virtual void slotAttributeDown();
    
signals:
    void sigEnableNextButton(bool);   
};

#endif
