//
// C++ Interface: %{MODULE}
//
// Description: 
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGCREATEFUNCTIONWIDGET2_H
#define KPGCREATEFUNCTIONWIDGET2_H

#include <kpgcreatefunctionwidget2base.h>

/**
Widget for create function Wizard

@author Lumir Vanek
*/

class KPGDatabase;

class KPGCreateFunctionWidget2 : public KPGCreateFunctionWidget2Base
{
Q_OBJECT
public:
    KPGCreateFunctionWidget2(QWidget *parent, const char *name, KPGDatabase *);
    ~KPGCreateFunctionWidget2();

    const QString getFuncParams() const;
    const QString getSQL() const;

    void refreshListOfReturnTypes();
    void refreshListOfArgumentTypes();    
    
protected:
    KPGDatabase *m_pDatabase;
    QString strNewDatatype;   
    
protected slots:
    
    virtual void slotRetTypeSchemaActivated(int);
    virtual void slotArgTypeSchemaActivated(int);
    virtual void slotComboReturnTypeActivated(const QString &);
    virtual void slotComboArgumentTypeActivated(const QString &);
    virtual void slotColumnSelectionChanged(QListViewItem *);
    virtual void slotArgumentCurrentChanged(QListViewItem *);
    virtual void slotCheckBoxWithoutReturnToggled(bool);
    
    virtual void slotArgumentAdd();
    virtual void slotArgumentDelete();
    virtual void slotArgumentUp();
    virtual void slotArgumentDown();
     
    virtual void slotAddNewDatatype(); 
      
signals:
    void sigEnableNextButton(bool);   
};

#endif
