//
// C++ Interface: %{MODULE}
//
// Description: 
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGCREATELANGUAGEWIDGET2_H
#define KPGCREATELANGUAGEWIDGET2_H

#include "kpgcreatelanguagewidget2base.h"

/**
Widget for create language Wizard

@author Lumir Vanek
*/

class KPGCreateLanguageWidget2 : public KPGCreateLanguageWidget2Base
{
Q_OBJECT
public:
    KPGCreateLanguageWidget2(QWidget *parent, const char *name, bool = true);
    ~KPGCreateLanguageWidget2();

    void setLanguageName(const QString &strLanguageName) { m_strLanguageName = strLanguageName; }
    const QString getSQL() const;

protected:
    void enableAddGrantButton();
    
protected:
    QString m_strLanguageName; // name of the created language
    
    QString strGR; // contain GRANT or REVOKE
    QString strTF; // contain TO or FROM
    
    bool m_bGrantOrRevoke;
    
protected slots:

    virtual void slotCheckBoxPublicToggled(bool);
    virtual void slotListBoxUsersSelectionChanged();
    
    virtual void slotGrantOptionsToggled(bool);
    
    virtual void slotGrantsSelectionChanged(QListViewItem *);
    virtual void slotGrantsCurrentChanged(QListViewItem *);
    
    virtual void slotGrantAdd();
    virtual void slotGrantDelete();
            
signals:
    void sigEnableNextButton(bool);   
};

#endif
