//
// C++ Interface: %{MODULE}
//
// Description: 
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGCREATESCHEMAWIDGET2_H
#define KPGCREATESCHEMAWIDGET2_H

#include "kpgcreateschemawidget2base.h"

/**
Widget for create schema Wizard

@author Lumir Vanek
*/

class KPGCreateSchemaWidget2 : public KPGCreateSchemaWidget2Base
{
Q_OBJECT
public:
    KPGCreateSchemaWidget2(QWidget *parent, const char *name, bool = true);
    ~KPGCreateSchemaWidget2();

    void setSchemaName(const QString &strSchemaName) { m_strSchemaName = strSchemaName; }
    const QString getSQL() const;

protected:
    QString m_strSchemaName;
    
    QString strGR; // contain GRANT or REVOKE
    QString strTF; // contain TO or FROM
    
    bool m_bGrantOrRevoke;
    
protected:
    void enableAddGrantButton();
    
protected slots:

    virtual void slotCheckBoxAllToggled(bool);
    virtual void slotCheckBoxCreateToggled(bool);
    virtual void slotCheckBoxUsageToggled(bool);
    virtual void slotGrantOptionsToggled(bool);    
    
    virtual void slotCheckBoxPublicToggled(bool);
    virtual void slotListBoxUsersSelectionChanged();
    
    virtual void slotGrantsSelectionChanged(QListViewItem *);
    virtual void slotGrantsCurrentChanged(QListViewItem *);
    
    virtual void slotGrantAdd();
    virtual void slotGrantDelete();
            
signals:
    void sigEnableNextButton(bool); 
};

#endif
