//
// C++ Interface: %{MODULE}
//
// Description: 
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGCREATETABLESPACEWIDGET2_H
#define KPGCREATETABLESPACEWIDGET2_H

#include "kpgcreatetablespacewidget2base.h"

/**
Widget for create tablespace Wizard

@author Lumir Vanek
*/

class KPGCreateTablespaceWidget2 : public KPGCreateTablespaceWidget2Base
{
Q_OBJECT
public:
    KPGCreateTablespaceWidget2(QWidget *parent, const char *name, bool = true);
    ~KPGCreateTablespaceWidget2();

    void setTablespaceName(const QString &strTablespaceName) { m_strTablespaceName = strTablespaceName; }
    const QString getSQL() const;

protected:
    void enableAddGrantButton();
    
protected:
    QString m_strTablespaceName; // name of the created tablespace
            
    QString strGR; // contain GRANT or REVOKE
    QString strTF; // contain TO or FROM
    
    bool m_bGrantOrRevoke;
    
protected slots:

    virtual void slotCheckBoxPublicToggled(bool);
    virtual void slotListBoxUsersSelectionChanged();
    
    virtual void slotGrantOptionsToggled(bool);
    
    virtual void slotGrantsSelectionChanged(QListViewItem *);
    virtual void slotGrantsCurrentChanged(QListViewItem *);
    
    virtual void slotGrantAdd();
    virtual void slotGrantDelete();
            
signals:
    void sigEnableNextButton(bool);  
};

#endif
