//
// C++ Interface: kpgcreatetriggerwidget1
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGCREATETRIGGERWIDGET1_H
#define KPGCREATETRIGGERWIDGET1_H

#include "kpgcreatetriggerwidget1base.h"

class KPGDatabase;

/**
Widget for create trigger Wizard

@author Lumir Vanek
*/

class KPGCreateTriggerWidget1 : public KPGCreateTriggerWidget1Base
{
Q_OBJECT
public:
    KPGCreateTriggerWidget1(QWidget *parent, const char *name, KPGDatabase *, const QString &, const QString &);
    ~KPGCreateTriggerWidget1();
		    
    const QString getSQL() const;
    	
protected:
	void refreshListOfFunctions();

protected:
    QString m_strNamespace; // quoted name of the table namespace
    QString m_strTableName; // quoted name of the table
    KPGDatabase *m_pDatabase;
        		
protected slots:

	virtual void slotTriggerNameChanged(const QString&);
	virtual void slotInsertToggled(bool);
	virtual void slotUpdateToggled(bool);
	virtual void slotDeleteToggled(bool);
    virtual void slotSchemaActivated(int);
    virtual void slotFunctionActivated(const QString &);
		
signals:
	void sigEnableNextButton(bool);
};

#endif
