//
// C++ Interface: kpgdroptableobjectwizard
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGDROPTABLEOBJECTWIZARD_H
#define KPGDROPTABLEOBJECTWIZARD_H

#include "kpg3stepswizard.h"

/**
Wizard for DROP table object, e.g. column, constraint ...

	@author Lumir Vanek <lvanek@users.sourceforge.net>
*/
class KPGDropTableObjectWizard : public KPG3StepsWizard
{
public:
    KPGDropTableObjectWizard(QWidget *parent, const char *name, const QString &, const QString &, const QString &, const QString & = QString::null);
    ~KPGDropTableObjectWizard();

protected:
    virtual void showPage(QWidget *);
		
protected:
	QString m_strObjectType; // type of the dropped table - COLUMN, CONSTRAINT ...
    QString m_strObjectName; // name of the dropped object
    QString m_strNamespace;  // name of the namespace
	QString m_strTable;		 // name of the table, that contain dropped object (index, rule, trigger ...)
	
protected slots:
    virtual void languageChange(); 
};

#endif
