//
// C++ Interface: %{MODULE}
//
// Description: 
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGPRIVILEGESWIZARD_H
#define KPGPRIVILEGESWIZARD_H

#include "kpg3stepswizard.h"

class KPGServer;

/**
Wizard for grant/revoke privileges

@author Lumir Vanek
*/

class KPGPrivilegesWizard : public KPG3StepsWizard
{
Q_OBJECT
public:
    // enumeration of objects, that allow change ACL using this wizard
    enum eObjectType { typeTable, typeView, typeSequence, typeDatabase, typeTablespace, typeFunction, typeLanguage, typeSchema };
    
    KPGPrivilegesWizard(QWidget *, const char *name, eObjectType, bool, KPGServer *, const QString &, const QString &, const QString & = QString::null);
    ~KPGPrivilegesWizard();
        
protected:    
    bool m_bGrantOrRevoke;
    eObjectType m_objType;
    
protected:
    virtual void showPage(QWidget *);
    
protected slots:
    virtual void languageChange();    
};

#endif
