//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "kpggeneralsettings.h"

#include <klocale.h>
#include <kconfig.h>
#include <kdebug.h>
#include <kcolorbutton.h>

#include <qframe.h>
#include <qcheckbox.h>

#include "kpggeneralsettingspage.h"

#define CONF_ENTRY_NAME_AUTO_LOAD_SYS_SCHEMAS "AutoLoadSysSchemas"
#define DFLT_VALUE_AUTO_LOAD_SYS_SCHEMAS true

#define CONF_ENTRY_NAME_AUTO_LOAD_USR_SCHEMAS "AutoLoadUsrSchemas"
#define DFLT_VALUE_AUTO_LOAD_USR_SCHEMAS true

#define CONF_ENTRY_NAME_USE_DOLLARS_FOR_FNC_BODY "UseDollarsForFncBody"
#define DFLT_VALUE_USE_DOLLARS_FOR_FNC_BODY false


KPGGeneralSettings::KPGGeneralSettings( QObject * pParent, const char * pszName )
 : KPGSettings( "General", pParent, pszName ),
   m_bAutoLoadSysSchemas( DFLT_VALUE_AUTO_LOAD_SYS_SCHEMAS ),
   m_bAutoLoadUsrSchemas( DFLT_VALUE_AUTO_LOAD_USR_SCHEMAS ),
   m_bUseDollarsForFncBody( DFLT_VALUE_USE_DOLLARS_FOR_FNC_BODY ),
   m_pDialogPage(0)
{
}

KPGGeneralSettings::~KPGGeneralSettings()
{
}

void KPGGeneralSettings::write( KConfig * pConfig ) const
{
	pConfig->writeEntry( CONF_ENTRY_NAME_AUTO_LOAD_SYS_SCHEMAS, m_bAutoLoadSysSchemas );
	pConfig->writeEntry( CONF_ENTRY_NAME_AUTO_LOAD_USR_SCHEMAS, m_bAutoLoadUsrSchemas );
	pConfig->writeEntry( CONF_ENTRY_NAME_USE_DOLLARS_FOR_FNC_BODY, m_bUseDollarsForFncBody );
}

void KPGGeneralSettings::read( const KConfig * pConfig )
{
	m_bAutoLoadSysSchemas = pConfig->readBoolEntry( CONF_ENTRY_NAME_AUTO_LOAD_SYS_SCHEMAS, DFLT_VALUE_AUTO_LOAD_SYS_SCHEMAS );
	m_bAutoLoadUsrSchemas = pConfig->readBoolEntry( CONF_ENTRY_NAME_AUTO_LOAD_USR_SCHEMAS, DFLT_VALUE_AUTO_LOAD_USR_SCHEMAS );
	m_bUseDollarsForFncBody = pConfig->readBoolEntry( CONF_ENTRY_NAME_USE_DOLLARS_FOR_FNC_BODY, DFLT_VALUE_USE_DOLLARS_FOR_FNC_BODY );
}

QString KPGGeneralSettings::dialogPageName() const
{
  	return i18n( "General" );
}

QString KPGGeneralSettings::dialogPageHeader() const
{
  	return i18n( "General setting" );
}

QString KPGGeneralSettings::dialogPageIcon() const
{
  	return "kpogre";
}

QWidget * KPGGeneralSettings::dialogPage( QFrame * pParent )
{
	if ( ! m_pDialogPage )
	{
		// create the page if necessary
		m_pDialogPage = new KPGGeneralSettingsPage( pParent, "general setting config.dialog page" );
	
		// and fill its widgets with the corresponding values
		updatePage();
	
		connect( m_pDialogPage->m_pCheckBoxAutoLoadSysSchemas, SIGNAL(toggled(bool)), this, SIGNAL(sigDialogPageChanged()) );
		connect( m_pDialogPage->m_pCheckBoxAutoLoadUsrSchemas, SIGNAL(toggled(bool)), this, SIGNAL(sigDialogPageChanged()) );
		connect( m_pDialogPage->m_pCheckBoxUseDollarsForFncBody, SIGNAL(toggled(bool)), this, SIGNAL(sigDialogPageChanged()) ); 
	}
	
	return m_pDialogPage;
}

void KPGGeneralSettings::setFromPage()
{
	if ( m_pDialogPage )
	{
		m_bAutoLoadSysSchemas = m_pDialogPage->m_pCheckBoxAutoLoadSysSchemas->isChecked();
		m_bAutoLoadUsrSchemas = m_pDialogPage->m_pCheckBoxAutoLoadUsrSchemas->isChecked();
		m_bUseDollarsForFncBody = m_pDialogPage->m_pCheckBoxUseDollarsForFncBody->isChecked();
	}
}

void KPGGeneralSettings::updatePage() const
{
	if ( m_pDialogPage )
	{
		m_pDialogPage->m_pCheckBoxAutoLoadSysSchemas->setChecked( m_bAutoLoadSysSchemas );
		m_pDialogPage->m_pCheckBoxAutoLoadUsrSchemas->setChecked( m_bAutoLoadUsrSchemas );
		m_pDialogPage->m_pCheckBoxUseDollarsForFncBody->setChecked( m_bUseDollarsForFncBody );
	}
}

