//
// C++ Implementation: kpgutil
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "kpgutil.h"

// include files for KDE
#include <kdebug.h>


KPGUtil::KPGUtil()
{
}

KPGUtil::~KPGUtil()
{
}

const QString KPGUtil::quotedName(const QString &strName)
{
	if(strName.contains('\"'))
	{
		kdError() << k_funcinfo << "Name already contain quote: " << strName << endl;
	}
	
	if(strName.contains('('))
	{
		int indexOfLeftParenthesis = strName.find('(');
		QString strNamePart1 = strName.left(indexOfLeftParenthesis);
		QString strNamePart2 = strName.mid(indexOfLeftParenthesis, strName.length() - indexOfLeftParenthesis);
		
		kdDebug() << strName << endl;
		kdDebug() << strNamePart1 << endl;
		kdDebug() << strNamePart2 << endl;
		
		if(strNamePart1.contains(' '))
		{
			return QString("\"" + strNamePart1 + "\"" + strNamePart2);
		}
	}
	else
	{
		if(strName.contains(' '))
		{
			return QString("\"" + strName + "\"");
		}
	}
	
	return strName;
}

const QString KPGUtil::unspacedName(const QString &strName)
{
	QString strNameUnspaced = strName;
	strNameUnspaced.replace(" ", "_");
	return strNameUnspaced;
}

const QString KPGUtil::unquotedName(const QString &strName)
{
	QString strNameUnquoted = strName;
	strNameUnquoted.replace("\"", "");
	return strNameUnquoted;
}


const QString KPGUtil::fullyQualifiedName(
	const QString &strNamespaceName, 
	const QString &strObjectName)
{
	return QString(quotedName(strNamespaceName) + "." + quotedName(strObjectName));
}
